package org.yaoqiang.bpmn.model.elements.core.common;

import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLFactory;
import org.yaoqiang.bpmn.model.elements.activities.GlobalBusinessRuleTask;
import org.yaoqiang.bpmn.model.elements.activities.GlobalScriptTask;
import org.yaoqiang.bpmn.model.elements.humaninteraction.GlobalManualTask;
import org.yaoqiang.bpmn.model.elements.humaninteraction.GlobalUserTask;
import org.yaoqiang.bpmn.model.elements.process.BPMNProcess;
import org.yaoqiang.bpmn.model.elements.process.GlobalTask;

/**
 * CallableElements
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class CallableElements extends XMLFactory {

	public CallableElements(XMLElement parent) {
		super(parent, "callableElements");
	}

	public XMLElement generateNewElement() {
		if (type.equals("process")) {
			return new BPMNProcess(this);
		} else if (type.equals("globalBusinessRuleTask")) {
			return new GlobalBusinessRuleTask(this);
		} else if (type.equals("globalManualTask")) {
			return new GlobalManualTask(this);
		} else if (type.equals("globalScriptTask")) {
			return new GlobalScriptTask(this);
		} else if (type.equals("globalTask")) {
			return new GlobalTask(this);
		} else if (type.equals("globalUserTask")) {
			return new GlobalUserTask(this);
		} 
		return null;
	}
	
}
