package org.yaoqiang.bpmn.model.elements.core.foundation;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLTextElements;

/**
 * Relationship
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Relationship extends BaseElement {

	public Relationship(Relationships parent) {
		super(parent, "relationship");
	}

	protected void fillStructure() {
		XMLAttribute attrType = new XMLAttribute(this, "type");
		XMLAttribute attrDirection = new XMLAttribute(this, "direction");
		XMLTextElements refSources = new XMLTextElements(this, "source");
		XMLTextElements refTargets = new XMLTextElements(this, "target");

		super.fillStructure();
		add(attrType);
		add(attrDirection);
		add(refSources);
		add(refTargets);
	}

	public Relationships getParent() {
		return (Relationships) parent;
	}

	enum RelationshipDirection {

		None("None"), Forward("Forward"), Backward("Backward"), Both("Both");

		private String direction;

		RelationshipDirection(String direction) {
			this.setDirection(direction);
		}

		public void setDirection(String direction) {
			this.direction = direction;
		}

		public String getDirection() {
			return direction;
		}

	}
}
