package org.yaoqiang.bpmn.model.elements.data;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLComplexElement;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.events.ThrowEvent;

/**
 * DataInputAssociation
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class DataInputAssociation extends DataAssociation {

	public DataInputAssociation(DataInputAssociations parent) {
		super(parent, "dataInputAssociation");
	}

	public final List<XMLElement> getAvailableDataInputs() {
		XMLComplexElement parent = (XMLComplexElement) getParent().getParent();
		if (parent instanceof ThrowEvent) {
			return ((ThrowEvent) parent).getDataInputList();
		} else {
			return ((InputOutputSpecification) parent.get("ioSpecification")).getDataInputs().getXMLElements();
		}
	}

	public DataInputAssociations getParent() {
		return (DataInputAssociations) parent;
	}

}
