package org.yaoqiang.bpmn.model.elements.data;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLComplexElement;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.events.CatchEvent;

/**
 * DataOutputAssociation
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class DataOutputAssociation extends DataAssociation {

	public DataOutputAssociation(DataOutputAssociations parent) {
		super(parent, "dataOutputAssociation");
	}

	public final List<XMLElement> getAvailableDataOutputs() {
		XMLComplexElement parent = (XMLComplexElement) getParent().getParent();
		if (parent instanceof CatchEvent) {
			return ((CatchEvent) parent).getDataOutputList();
		} else {
			return ((InputOutputSpecification) parent.get("ioSpecification")).getDataOutputs().getXMLElements();
		}
	}

	public DataOutputAssociations getParent() {
		return (DataOutputAssociations) parent;
	}

}
