package org.yaoqiang.bpmn.model.elements.data;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLTextElements;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * InputSet
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class InputSet extends BaseElement {

	public InputSet(XMLElement parent) {
		super(parent, "inputSet");
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		XMLTextElements refDataInputRefs = new XMLTextElements(this, "dataInputRefs");
		XMLTextElements refOptionalInputRefs = new XMLTextElements(this, "optionalInputRefs");
		XMLTextElements refWhileExecutingInputRefs = new XMLTextElements(this, "whileExecutingInputRefs");
		XMLTextElements refOutputSetRefs = new XMLTextElements(this, "outputSetRefs");

		super.fillStructure();
		add(attrName);
		add(refDataInputRefs);
		add(refOptionalInputRefs);
		add(refWhileExecutingInputRefs);
		add(refOutputSetRefs);
	}

	public final XMLTextElements getDataInputRefs() {
		return (XMLTextElements) get("dataInputRefs");
	}

}
