package org.yaoqiang.bpmn.model.elements.gateways;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.core.common.Expression;
import org.yaoqiang.bpmn.model.elements.core.common.FlowElements;
import org.yaoqiang.bpmn.model.elements.core.common.SequenceFlow;

/**
 * ComplexGateway
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ComplexGateway extends Gateway {

	public ComplexGateway(FlowElements parent) {
		super(parent, "complexGateway");
	}

	protected void fillStructure() {
		XMLAttribute attrDefault = new XMLAttribute(this, "default");
		Expression refActivationCondition = new Expression(this, "activationCondition");

		super.fillStructure();
		add(attrDefault);
		add(refActivationCondition);
	}

	public SequenceFlow getDefaultSequenceFlow() {
		return (SequenceFlow) getParent().getFlowElement(get("default").toValue());
	}

}
