package org.yaoqiang.graph.editor.handler;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.List;

import javax.swing.JComponent;

import org.yaoqiang.graph.editor.action.EditorActions;
import org.yaoqiang.graph.editor.swing.GraphComponent;
import org.yaoqiang.graph.handler.YGraphTransferHandler;

import com.mxgraph.swing.util.mxGraphTransferable;

/**
 * GraphTransferHandler
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class GraphTransferHandler extends YGraphTransferHandler {

	private static final long serialVersionUID = 1L;

	public boolean importData(JComponent c, Transferable t)
	{
		boolean result = false;

		if (isLocalDrag())
		{
			// Enables visual feedback on the Mac
			result = true;
		}
		else
		{
			try
			{
				updateImportCount(t);

				if (c instanceof GraphComponent)
				{
					GraphComponent graphComponent = (GraphComponent) c;

					if (graphComponent.isEnabled()) {
						if(t.isDataFlavorSupported(mxGraphTransferable.dataFlavor)) {
							mxGraphTransferable gt = (mxGraphTransferable) t.getTransferData(mxGraphTransferable.dataFlavor);
							if (gt.getCells() != null)	{
								result = importGraphTransferable(graphComponent, gt);
							}
						} else if (t.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
							// ==============start==============
							List<?> files = (List<?>) t.getTransferData(DataFlavor.javaFileListFlavor);
							if (!files.isEmpty() && files.size() == 1) {
								File file = (File) files.get(0);
								EditorActions.getOpenAction(file.getAbsolutePath()).actionPerformed(new ActionEvent(graphComponent, 0, ""));
							}
							// ==============end================
						}
					}
				}
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
		}

		return result;
	}
	
}
